/* l2tpServer.js - API library for L2TP Server configuration */

/* Copyright 2011 TeamF1, Inc. */

/*
modification history 
------------------------
01a,23AUG11,mvb  written. 
*/


function l2tpEnableCheck ()
    {
    if(!(document.getElementById('chkEnable').checked))
        fieldStateChangeWr ('txtTimeOut chkPap chkChap chkMschap chkMschapv2', 'tblL2tpStrtIpAddr tblL2tpEndIpAddr', '', '')
    else
        fieldStateChangeWr ('', '', 'txtTimeOut chkPap chkChap chkMschap chkMschapv2', 'tblL2tpStrtIpAddr tblL2tpEndIpAddr')
    }

function l2tpServerValidate ()
    {
    var checkEnableObj = document.getElementById('chkEnable');
    if(checkEnableObj.checked)
    {
    if (ipv4AddrOctetsValidate ('tblL2tpStrtIpAddr', 'IPD', false, true,
             "Invalid Starting IP address.", "for octet", true) == false)
         return false;
    if (ipv4AddrOctetsValidate ('tblL2tpEndIpAddr', 'IPD', false, true,
             "Invalid Ending IP address.", "for octet", true) == false)
         return false;
    
    var ipAddrObj = document.getElementById ('tblL2tpStrtIpAddr');
    if (ipAddrObj && ipAddrObj.disabled) return true;
    
    var stIpAddr = getIPInt("tblL2tpStrtIpAddr");
    var endIpAddr = getIPInt("tblL2tpEndIpAddr");
    var snetMask = getIPInt1("hdSnetMask");
    if (!isInSubnet(endIpAddr, stIpAddr, snetMask))
        {
        var errorstr = "Starting and Ending IP Address must be in same subnet.";
        if (document.getElementById('txtStartIpErr'))
            document.getElementById('txtStartIpErr').innerHTML = errorstr
        else
            alert (errorstr)
            return false;
        }
        
    if (endIpAddr - stIpAddr < 0)
        {
        var errorstr = "Ending IP Address should be higher than Starting IP Address.";
        if (document.getElementById('txtEndIpErr'))
            document.getElementById('txtEndIpErr').innerHTML = errorstr
        else
            alert (errorstr)
            return false;
        }
    else if(endIpAddr - stIpAddr == 0)
        {
        var errorstr = "Ending IP Address should not be equal to Starting IP Address.";
        if (document.getElementById('txtEndIpErr'))
            document.getElementById('txtEndIpErr').innerHTML = errorstr
        else
            alert (errorstr);
            ipAddrObj.focus ();
            return false;
        }
    
    if (endIpAddr - stIpAddr > 25)
        {
        var errorstr = "Starting and Ending IP Address range must be less than or equal to 26.";
        if (document.getElementById('txtEndIpErr'))
            document.getElementById('txtEndIpErr').innerHTML = errorstr
        else
            alert (errorstr)
            return false;
        }
    /*Begin:Subnet Checking for Dmz*/
    if(ipAddrObj && !ipAddrObj.disabled)
        {
        if(document.getElementById('dmzIp').value != '0.0.0.0' && document.getElementById('dmzSnet').value != '0.0.0.0')
            {
            var dmzIPAddr = getIPInt1("dmzIp");
            var dmzsnetMask = getIPInt1("dmzSnet");
            if(isInSubnet(stIpAddr, dmzIPAddr, dmzsnetMask))
                {
                var errorstr = "DMZ IP address is in the same subnet. Please specify IP address in a different subnet.";
                alert (errorstr);
                return false;
                }
            }
        }
    /*End:Subnet Checking for Dmz*/
    
    /*Begin:Subnet Checking for LAN*/
    if(ipAddrObj && !ipAddrObj.disabled)
        {
        var i = 0;
        var l2tpCurIp = getIPInt('tblL2tpStrtIpAddr');
        var l2tpIPObj = document.getElementById('tblL2tpStrtIpAddr');
        var numObj = document.getElementById('hdNum');
        var numObjVal = parseInt(numObj.value,10);
        var intIP = "";
        var intIpMask = "";
        if(numObj)
            {
            while (i <= numObjVal)
                {
                i= i + 1;
                intIPId = "hdLanIPAddr"+i;
                intIPMaskId = "hdLanSnetAddr"+i;
                if(document.getElementById(intIPId))
                    {
                    var intIp = getIPInt1(intIPId);
                    var intIpMask = getIPInt1(intIPMaskId);
                    if(document.getElementById(intIPId).value != '0.0.0.0' && document.getElementById(intIPMaskId).value != '0.0.0.0')
                        {
                        if(isInSubnet(l2tpCurIp, intIp, intIpMask))
                            {
                            var errorstr = "The subnet specified is same as LAN/VLAN subnet, Please specify a different subnet.";
                            alert (errorstr)
                            l2tpIPObj.focus();
                            return false;
                            }
                        }
                    }
                }
            }
        }
    /*End:Subnet Checking for LAN*/
    
    /*Begin:Subnet Checking for L2TP Start Ip Address*/
    if(ipAddrObj && !ipAddrObj.disabled)
        {
        if(document.getElementById('hdpptpIpAddr').value != '0.0.0.0' && document.getElementById('hdpptpIpAddr').value != '')
            {
            var pptpIPAddr = getIPInt1("hdpptpIpAddr");
            var pptpsnetMask = getIPInt1("hdpptpSubnetmask");
            if(isInSubnet(stIpAddr, pptpIPAddr, pptpsnetMask))
                {
                var errorstr = "PPTP Start IP Address is in the same subnet. Please specify IP address in a different subnet.";
                alert (errorstr);
                ipAddrObj.focus ();
                return false;
                }
            }
        }
    /*End:Subnet Checking for */
    var txtFieldIdArr = new Array ();    
    txtFieldIdArr[0] = "txtTimeOut,Please enter the Value between 0-999";
    if (txtFieldArrayCheck (txtFieldIdArr) == false)
         return false;
    var txtTimeOutObj = document.getElementById('txtTimeOut');
    if(txtTimeOutObj)
        {        
        if(numericValueRangeCheck (txtTimeOutObj, '', '', 0, 999, true, '', 'Minutes') == false) 
            return false;            
        }
    
    }    
    if (checkAuthEnabled () == false) {
        alert ("Please select atleast one check box in Authentication section.");
        return false;
    }
    return true;
    }
