/* diagnostics.js - API library for Diagnostics configuration */

/* Copyright 2010 TeamF1, Inc. */

/*
modification history 
------------------------
01b,9NOV10,mvb modified both functions.
01a,12OCT10,hb written.
*/

/********************************************************************
* changeButtonStatus : Based selected button press enables/diables the buttons 
*
* This function enables/disables the buttons and dropdown list 
* based on button press value
*
* RETURNS: N/A
*/

function changeButtonStatus (ptraceStatus)
    {
    if (ptraceStatus == null)
        return false;
    
    var btImgStartObj = document.getElementById ('btImgStart');
    if (!btImgStartObj) return;
    var btImgStopObj= document.getElementById ('btImgStop');
    if (!btImgStopObj) return;
    var btImgDownloadObj = document.getElementById ('btImgDownload');
    if (!btImgDownloadObj ) return;

    switch (ptraceStatus)
        {
        case 1:    /* packet trace started */
            btImgStartObj.className = "submit_dis submit3 bSelectall"
            btImgStartObj.onclick = function () {return false;};
            btImgStopObj.className = "submit submit3 bStop"
            btImgStopObj.onclick = function () {return true;};        
            btImgDownloadObj.className = "submit_dis submit3 bDownload"
            btImgDownloadObj.onclick = function () {return false;};
            fieldStateChangeWr ('selNetwork btImgDownload btImgStart','','btImgStop','');
            break;
        case 2:    /* packet trace stopped */
            btImgStartObj.className = "submit submit3 bSelectall"
            btImgStartObj.onclick = function () {return true};
            btImgStopObj.className = "submit_dis submit3 bStop"
            btImgStopObj.onclick = function () {return false;};        
            btImgDownloadObj.className = "submit submit3 bDownload"
            btImgDownloadObj.onclick = function () { return true; };
            fieldStateChangeWr ('btImgStop','','selNetwork btImgDownload btImgStart','');
            break;
        default:
            btImgStartObj.className = "submit submit3 bSelectall"
            btImgStartObj.onclick = function () {return true;};
            btImgStopObj.className = "submit_dis submit3 bStop"
            btImgStopObj.onclick = function () {return false;};        
            btImgDownloadObj.className = "submit submit3 bDownload"
            btImgDownloadObj.onclick = function () {return false;};
            fieldStateChangeWr ('btImgStop','','selNetwork','');
            break;
        }
    return true;
    }

/********************************************************************
* popDiagPtraceInit : Get the selected pressd button value 
*
* This function enables/disables the buttons and dropdown list 
* based on pressed button value
* we are calling this in onload 
*
* RETURNS: N/A
*/    
function popDiagPtraceInit ()
    {
    var ptStatus = document.getElementById ('hdBtPressed').value;
    if (ptStatus == null) return;
    return changeButtonStatus (parseInt (ptStatus, 10));
    }
        

